#include "p24FJ128GA010.h"
#include <time.h>
#include <uart.h>
#include <math.h>
//#include <main.h>
#include "periferial.h"

#define FCY  10000000uL
#define Delay_ms(d) (__delay32 (((d)) * ((FCY) / 1000uL)))
#define Delay_us(d) (__delay32 (((d)) * ((FCY) / 1000000uL)))

#define USE_AND


/************************************************************************
*
*     : adc1config
*
*    :  -
*
*     :  -
*							 
*   :    ADC,  :   (2,8.) 
*
************************************************************************/
 
void ADCinit(void)					//  
{	
	//AD1PCFG = 0xFFFF;
	// ADC  :
	//.AN=0bFEDCBA9876543210 		
	AD1PCFG = 0b0000000000110000;		//.     


	// AD1CON2
	AD1CON2bits.BUFM = 1;			// 16 
	AD1CON2bits.VCFG = 0;		 	//bit 15-3:Vr+ = Vdd; Vr- = Vss;
				
	AD1CON3bits.ADCS = 2;	 		//bit 7-0: (Tcy = 62,5 .);   1/2*62,5=8
														//Tad = Tcy*(ADCS + 1))/2= 100*(2+1)/2= 150 ()
														//  Tconv=12*Tad = 1,8  
	AD1CON3bits.SAMC = 10;	 	//bit 12-8:  Tsamp=10*Tad=10*100=1   
														//Tsamp + Tconv = 1,8 + 1 = 2.8 							 
	AD1CON1bits.SSRC = 7;		 	//bit 7-5: .   
													 	//   ()
	
	AD1CON1bits.ASAM = 0;			//    												
	
	AD1CON1bits.FORM = 0;		 	// - "signed integer"	
	AD1CON2bits.SMPI = 0;		 	//    

  AD1CON3bits.ADRC = 0;		 	//     Fcy = 10  
		
	AD1CSSL = 0x0000;					//  
		
	AD1CON1bits.ADON = 0;			//. 
	//*/		
}

//  ADC()
//EnableADC1;  								//. ADC1
//DisableADC1;  							//. ADC1
//EnableIntADC1;  
//DisableIntADC1;  
//SetPriorityIntADC1;  
//ADC1_Clear_Intr_Status_Bit;  
//StopSampADC1;  
//BusySampADC1;

// ,      
unsigned int adcread(void) 	// 
{			
	AD1CON1bits.SAMP = 1; 	 					//  		
	while(!AD1CON1bits.DONE);					//   
	AD1CON1bits.DONE = 0;							//   
	return (ADC1BUF0);		 						//   
}

//  ADC     AN0..AN15
void adcKAN(char kanADC)
{	
	AD1CHS = kanADC;				 	// 0 - .  AN[kanADC] : adcKAN(1)    AN1
}

//      ADC_1..ADC_13, ADC_E_SW
//   
//char channel -    (ADC_1..ADC_13),  #define
extern unsigned int adcread_Extchan_mV(char channel) 		
{
	unsigned int in=0;
	
	adcKAN(channel); // 	
	in = adcread();	 // 
	//   :
	if(channel<=6)								//  ADC_1..ADC_5
		in = (float)in;// * Kadc_25V;
	if((channel>6)&&(channel<11))	//  ADC_6..ADC_9
		in = (float)in;// * Kadc_12V;
	if(channel == 7)					
		in = (float)in;// * Kadc_E_SW; //  E_SW
		
	return(in);		
}	

/*/  ADC:
void __attribute__((interrupt, no_auto_psv))_ADC1Interrupt(void)
{
	//...
	// 
	IFS0bits.AD1IF = 0;
}
void __attribute__((interrupt, no_auto_psv))_AltADC1Interrupt(void)
{
	//...
	// 
	IFS0bits.AD1IF = 0;
}//*/





