/*****************************************************************************
*
*     PIC24FJ128GA010
*
******************************************************************************
* 					:  periferial.h  
* 						:  PIC24FJ128GA010
* 		:  MPLAB C30 v3.23
* Linker				:  MPLAB LINK30
*****************************************************************************/

//
#ifndef Fcy
#define Fcy			10000000
#endif
extern void __delay32(unsigned long cycles); 

#define ON   	1
#define OFF	 	0

#define VKL  	1
#define VIKL 	0

#define TRUE  1
#define FALSE 0


//unsigned char cn;
//unsigned int CN;

/*************************************************************************
**************************************************************************
**********************************BUZZER**********************************
**************************************************************************
*************************************************************************/
#define SHORT_BEEP     	1
#define LONG_BEEP				2
#define TWOSHORT_BEEP 	3
#define BUZER          	PORTAbits.RA5
#define BUZER_TRIS     	TRISAbits.TRISA5
void beep(unsigned char BEEP); //  																//BUZZER

/*************************************************************************
**************************************************************************
**********************************UART************************************
**************************************************************************
*************************************************************************/

/*/  :
#define U1TX  3
#define U2TX  5
#define U3TX  28
#define U4TX  30
//*/

//  UART():
#define BAUDRATE_UART1 		9600
#define BAUDRATE_UART2 		9600
#define BAUDRATE_UART3 		9600
#define BAUDRATE_UART4 		9600																																//UART

//  UART    ( U1BRGH = 1)
#define U1BRG_VALUE 			Fcy/4/BAUDRATE_UART1-1
#define U2BRG_VALUE 			Fcy/4/BAUDRATE_UART2-1
#define U3BRG_VALUE 			Fcy/4/BAUDRATE_UART3-1
#define U4BRG_VALUE 			Fcy/4/BAUDRATE_UART4-1																									

#if U1BRG_VALUE > 1020
#error Ne vernaya skorost UART1.Ispravte znasenie
#endif
#if U2BRG_VALUE > 1020
#error Ne vernaya skorost UART2.Ispravte znasenie
#endif
#if U3BRG_VALUE > 1020
#error Ne vernaya skorost UART3.Ispravte znasenie
#endif
#if U4BRG_VALUE > 1020
#error Ne vernaya skorost UART4.Ispravte znasenie																							//UART
#endif

#define BAUDRATE_MISTAKE1 			1000*(BAUDRATE_UART1 - Fcy/4/(U1BRG_VALUE+1))/BAUDRATE_UART1
#if (BAUDRATE_MISTAKE1 > 2)||(BAUDRATE_MISTAKE1 < -2)
#warning pogreshnost skorosti UART1 > 2%!!!
#endif 

#define BAUDRATE_MISTAKE2 			1000*(BAUDRATE_UART2 - Fcy/4/(U2BRG_VALUE+1))/BAUDRATE_UART2
#if (BAUDRATE_MISTAKE2 > 2)||(BAUDRATE_MISTAKE2 < -2)
#warning pogreshnost skorosti UART2 > 2%!!!
#endif 

#define BAUDRATE_MISTAKE3 			1000*(BAUDRATE_UART3 - Fcy/4/(U3BRG_VALUE+1))/BAUDRATE_UART3
#if (BAUDRATE_MISTAKE3 > 2)||(BAUDRATE_MISTAKE3 < -2)
#warning pogreshnost skorosti UART3 > 2%!!!
#endif 

#define BAUDRATE_MISTAKE4 			1000*(BAUDRATE_UART4 - Fcy/4/(U4BRG_VALUE+1))/BAUDRATE_UART4	//UART
#if (BAUDRATE_MISTAKE4 > 2)||(BAUDRATE_MISTAKE4 < -2)
#warning pogreshnost skorosti UART4 > 2%!!!
#endif

//  / UART
#define UART1_ON U1MODEbits.UARTEN = 1;
#define UART2_ON U2MODEbits.UARTEN = 1;
#define UART3_ON U3MODEbits.UARTEN = 1;
#define UART4_ON U4MODEbits.UARTEN = 1;

#define UART1_OFF U1MODEbits.UARTEN = 0;
#define UART2_OFF U2MODEbits.UARTEN = 0;
#define UART3_OFF U3MODEbits.UARTEN = 0;
#define UART4_OFF U4MODEbits.UARTEN = 0;
																																														//UART
// 
#define ONE_BYTE_INT 		0
#define HTREE_BYTES_INT 1
#define FULL_BUF_INT 		3

// UART
extern unsigned char BUF_UART[4];
	
//*
void UART1init(void);
void UART2init(void);
void UART3init(void);
void UART4init(void);
//*/

//    UART(8  9      ( UXMODEbits.PDSEL))   
// : unsigned int DATA;  char DATA;
void WriteUART1(unsigned int data);
void WriteUART2(unsigned int data);					// 
void WriteUART3(unsigned int data);
void WriteUART4(unsigned int data);

//   UART
//     "/0"																							//UART
void putsUART1(unsigned int *buffer);				// 
void putsUART1(unsigned int *buffer);				
void putsUART1(unsigned int *buffer);				//		:
void putsUART1(unsigned int *buffer);				//		
																						//		char STR[] = "qwerty";																						//		
																						//		putsUART1(STR)
																						
//   ( );
//     -    !!!
//   8- ,  9  
unsigned int ReadUART1(void);								
unsigned int ReadUART2(void);								// 
unsigned int ReadUART3(void);
unsigned int ReadUART4(void);

//   (length)  UART     (*buffer)
//     ~("uart_data_wait"*19-1)  ;
// "0"    ;     -    
unsigned int getsUART1(unsigned int length,unsigned int *buffer,			
                       unsigned int uart_data_wait);																				//UART
unsigned int getsUART2(unsigned int length,unsigned int *buffer,				// 
                       unsigned int uart_data_wait);
unsigned int getsUART3(unsigned int length,unsigned int *buffer,				//	 :	
                       unsigned int uart_data_wait);										//	int *pnt;
unsigned int getsUART4(unsigned int length,unsigned int *buffer,				//  int BUF[10];											
                       unsigned int uart_data_wait);										//	pnt = &BUF[0];
                        																								//	getsUART1(10,pnt,65535)
																																				//   [(100*19)-1]*100=0,125
//   UART;
// 	PRT_U1RX -   Ȩ		(1..7)
// 	PRT_U1TX -   	(1..7)															
// 	char REGIM1  -   ; :
//		"0"- ,     					(#define )
//		"1"- ,     3 						()
//		"3"- ,    (4 ); 	() 
// 		 periferil.h: #define FULL_BUF_INT 3 , #define ONE_BYTE_INT 0, #define HTREE_BYTES_INT 1	
void ConfIntUART1(char PRT_U1RX,char PRT_U1TX,char REGIM1);
void ConfIntUART2(char PRT_U2RX,char PRT_U2TX,char REGIM2);	//:
void ConfIntUART3(char PRT_U3RX,char PRT_U3TX,char REGIM3);	//#define OFF 0
void ConfIntUART4(char PRT_U4RX,char PRT_U4TX,char REGIM4);	//#define ON 1												
																														//ConfIntUART1(6;6;ONE_BYTE_INT)		
																														// RX=6; TX=6;  
																														//   ;
																														 
/*/   :  
EnableIntU1RX; //  UART  
EnableIntU1TX; 
EnableIntU2RX;
EnableIntU2TX;
 
DisableIntU1RX;//  UART  
DisableIntU1TX;  
DisableIntU2RX;  
DisableIntU2TX;  

U1RX_Clear_Intr_Status_Bit; //    
U1TX_Clear_Intr_Status_Bit;  
U2RX_Clear_Intr_Status_Bit;  
U2TX_Clear_Intr_Status_Bit; 
//*/
																														
/*/  UART
void __attribute__ ((interrupt, no_auto_psv)) _U1RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U1TXInterrupt(void);														//UART
void __attribute__ ((interrupt, no_auto_psv)) _U2RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U2TXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U3RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U3TXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U4RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U4TXInterrupt(void);																		

void __attribute__ ((interrupt, no_auto_psv)) _AltU1RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltU1TXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltU2RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltU2TXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltU3RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltU3TXInterrupt(void);												//UART
void __attribute__ ((interrupt, no_auto_psv)) _AltU4RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltU4TXInterrupt(void);																			
//*/

/*************************************************************************
**************************************************************************
**********************************I2C************************************
**************************************************************************
*************************************************************************/

//  I2C:()
#define I2C1_SCL 						100000
#define I2C2_SCL 						100000
#define I2C3_SCL 						100000
																																															//I2C			
//  I2C:
#define I2C1BRG_VALUE 		Fcy/I2C1_SCL-(Fcy/10000000)-1
#define I2C2BRG_VALUE 		Fcy/I2C2_SCL-(Fcy/10000000)-1
#define I2C3BRG_VALUE 		Fcy/I2C3_SCL-(Fcy/10000000)-1

//  / I2C
#define I2C1_ON						I2C1CONbits.I2CEN = 1;
#define I2C2_ON						I2C2CONbits.I2CEN = 1;
#define I2C3_ON   				I2C3CONbits.I2CEN = 1;

#define I2C1_OFF					I2C1CONbits.I2CEN = 0;
#define I2C2_OFF					I2C2CONbits.I2CEN = 0;
#define I2C3_OFF   				I2C3CONbits.I2CEN	= 0;																						
																																															//I2C

/*/ :
EnableIntMI2C1; 							//    
EnableIntMI2C2; 
EnableIntSI2C1; 
EnableIntSI2C2;  
DisableIntMI2C1;  						//   
DisableIntMI2C2;  
DisableIntSI2C1;  
DisableIntSI2C2; 
MI2C1_Clear_Intr_Status_Bit;  //  
MI2C2_Clear_Intr_Status_Bit;  
SI2C1_Clear_Intr_Status_Bit;  
SI2C2_Clear_Intr_Status_Bit; 
//*/
																																												//I2C																											
//  I2C:
void I2C1_Init(void);
void I2C2_Init(void); 
//void I2C3_Init(void);

//  I2C:
void AckI2C1(void);					// ACK  
void AckI2C2(void);  				//  	
//void AckI2C3(void);
 
void CloseI2C1(void); 			//  I2C  	 
void CloseI2C2(void);  			//  
//void CloseI2C3(void);
  
//void ConfigIntI2C1(void); //  I2C
//void ConfigIntI2C2(void); //   
//void ConfigIntI2C3(void); 
  
char DataRdyI2C1(void);			//   I2CRCV "1" -  ; "0" -     
char DataRdyI2C2(void);  		// 
//char DataRdyI2C3(void);
  																																													//I2C
void IdleI2C1(void);  			// ,    
void IdleI2C2(void);  			// 
//void IdleI2C3(void);

char MasterputsI2C1(unsigned char *wrptr); 		//  i2C    wrptr
char MasterputsI2C2(unsigned char *wrptr); 		// "-3"     
//char MasterputsI2C3(unsigned char *wrptr); 	// "0",    "0"
																							// 	 

//    ; length- ; i2c_data_wait - 
//  ;  = (20*[i2c_data_wait] -1) 
//     -  "0"
//    -    
unsigned int  MastergetsI2C1(unsigned int length,unsigned char * rdptr,unsigned int i2c_data_wait); 
unsigned int  MastergetsI2C2(unsigned int length,unsigned char * rdptr,unsigned int i2c_data_wait);  
//unsigned int  MastergetsI2C3(unsigned int length,unsigned char * rdptr,unsigned int i2c_data_wait);  

unsigned char MasterReadI2C1(void); 		//      I2C
unsigned char MasterReadI2C2(void); 		//  
//unsigned char MasterReadI2C3(void);		// 

void MasterWaitForIntrI2C1(void);   		//      
void MasterWaitForIntrI2C2(void);   		//  
//void MasterWaitForIntrI2C3(void);
  
char MasterWriteI2C1(unsigned char data_out); 	//  (data_out)  I2C 
char MasterWriteI2C1(unsigned char data_out); 	// "-1",     , 
//char MasterWriteI2C1(unsigned char data_out); //  "0"
 																																															//I2C				
void NotAckI2C1(void); 			// NACK  
void NotAckI2C2(void);    
//void NotAckI2C3(void);    

void RestartI2C1(void); 		//      
void RestartI2C2(void);    
//void RestartI2C3(void);  

void StartI2C1(void); 			//    
void StartI2C2(void);  
//void StartI2C3(void);
  
void StopI2C1(void);				//  
void stopI2C2(void);  
//void StopI2C3(void);
																																														
/*/  I2C:
void __attribute__ ((interrupt, no_auto_psv)) _MI2C1Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _MI2C2Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _MI2C3Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _SI2C1Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _SI2C2Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _SI2C3Interrupt(void);
																																																//I2C
void __attribute__ ((interrupt, no_auto_psv)) _AltMI2C1Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltMI2C2Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltMI2C3Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltSI2C1Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltSI2C2Interrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _AltSI2C3Interrupt(void);
//*/


/*************************************************************************
**************************************************************************
*************************** I2C*************************************
**************************************************************************
*************************************************************************/
																																																			// I2C
//        I2C;

// :
#define CURR_1u_25m	8		//  	1..25 				(25)
#define VIDEO_GEN		20	//  									()
#define CURR_20_170 50	//   20..170 				()	
#define SINUS_GEN 	60  //  							()
#define POWER_1A		70	//  1A												(1A)
#define COMMUT1			80	// 1 										()
#define COMMUT2			81	// 2 										()
#define USIL_SINUS 	90 	//   ()
#define PROGR				100 // 										()
#define POWER_3_24 	110	//  3V3_24VA									(3V3_24)

//   
#define  MaxDev     20

//____________________________________________________________________________________________________
// -   I2C()
#define  i2c_videiGen_address_0          	20                      // -
#define  i2c_videiGen_address_1          	i2c_videiGen_address_0+1
#define  i2c_videiGen_address_2          	i2c_videiGen_address_0+2
#define  i2c_videiGen_address_3          	i2c_videiGen_address_0+3
//____________________________________________________________________________________________________
// -   I2C()
#define  i2c_master_address_0          		30											// -
#define  i2c_master_address_1          		i2c_master_address_0+1
#define  i2c_master_address_2          		i2c_master_address_0+2
#define  i2c_master_address_3          		i2c_master_address_0+3
//____________________________________________________________________________________________________   // I2C
//   250-25   I2C(25)
#define  i2c_current25_address_0         50												// -
#define  i2c_current25_address_1         i2c_current25_address_0+1
#define  i2c_current25_address_2         i2c_current25_address_0+2
#define  i2c_current25_address_3         i2c_current25_address_0+3
//____________________________________________________________________________________________________   // I2C
//   10-170   I2C()
#define  i2c_current170_address_0         50											// -
#define  i2c_current170_address_1         i2c_current170_address_0+1
#define  i2c_current170_address_2         i2c_current170_address_0+2
#define  i2c_current170_address_3         i2c_current170_address_0+3
//____________________________________________________________________________________________________
//     I2C()
#define  i2c_generator_address_0          60											// -
#define  i2c_generator_address_1          i2c_generator_address_0+1
#define  i2c_generator_address_2          i2c_generator_address_0+2
#define  i2c_generator_address_3          i2c_generator_address_0+3
//____________________________________________________________________________________________________   // I2C
//   1   I2C(1)
#define  i2c_power1A_address_0          	70											// -
#define  i2c_power1A_address_1          	i2c_power1A_address_0+1
#define  i2c_power1A_address_2          	i2c_power1A_address_0+2
#define  i2c_power1A_address_3          	i2c_power1A_address_0+3
//____________________________________________________________________________________________________
//     I2C()
#define  i2c_commmutator_address_0        80											// -
#define  i2c_commmutator_address_1        i2c_commmutator_address_0+1
#define  i2c_commmutator_address_2        i2c_commmutator_address_0+2
#define  i2c_commmutator_address_3        i2c_commmutator_address_0+3
//____________________________________________________________________________________________________
//       I2C()
#define  i2c_amplifier_address_0          90											// -
#define  i2c_amplifier_address_1          i2c_amplifier_address_0+1
#define  i2c_amplifier_address_2          i2c_amplifier_address_0+2
#define  i2c_amplifier_address_3          i2c_amplifier_address_0+3
//____________________________________________________________________________________________________   // I2C
//    I2C()
#define  i2c_programmer_address_0         100											// -
#define  i2c_programmer_address_1         i2c_programmer_address_0+1
#define  i2c_programmer_address_2         i2c_programmer_address_0+2
#define  i2c_programmer_address_3         i2c_programmer_address_0+3
//____________________________________________________________________________________________________
//   3-24   I2C(3V3_24)
#define  i2c_power24V_address_0        		8												// -
#define  i2c_power24V_address_1         	i2c_power24V_address_0+1
#define  i2c_power24V_address_2         	i2c_power24V_address_0+2
//____________________________________________________________________________________________________
//  -   I2C()
#define  i2c_vidADC_address_0         		25											// -
#define  i2c_vidADC_address_1         		i2c_vidADC_address_0+1
#define  i2c_vidADC_address_2         		i2c_vidADC_address_0+2
#define  i2c_vidADC_address_3         		i2c_vidADC_address_0+3

//____________________________________________________________________________________________________   // I2C
//     I2C
//____________________________________________________________________________________________________

//+++++++++++++++++   
//write 
#define  command_memory_WriteByte         			201 //   
//Read 
#define  command_memory_GetMemSize         			200 //     
#define  command_memory_ReadByte         				202 //   

//+++++++++++++++++    ()
//write 
#define  command_generator_SetFreq         			33 // 
#define  command_generator_SetAmp         			34 // 
#define  command_generator_on          					36 // 
#define  command_generator_off          				37 // 
#define  command_generator_AmpIncrement    			38 //   N 
#define  command_generator_AmpDecrement    			39 //   N 
//Read 
#define  command_generator_Status         			35 // 
																																																		// I2C
//+++++++++++++++++   	()
//write 
#define  command_Amplifier_SetAmp  							33 // 
#define  command_Amplifier_CNLOn  							34 // 
#define  command_Amplifier_CNLOff      					35 // 
#define  command_Amplifier_StrobeOnOff					14 //    
#define  command_Amplifier_ToMeasureAmplitude		17 // 
#define  command_Amplifier_FlagFreq							18 //   
#define  command_Amplifier_StrobeDelay					19 //   
//Read 
#define  command_Amplifier_StatusChannel				20 //  
#define  command_Amplifier_ToMeasureAmp					13 //  
																																																		// I2C
//+++++++++++++++++    1	(1) 
//write 
#define  command_power_Voltage_ON								20 //  
#define  command_power_set_curr_lim							21 //   
#define  command_power_OnOff_3v3_XP42						22 //  /  
#define  command_power_MeasureVoltCurr					23 //       
#define  command_power_GND_XP42_ON							24 // GND  XP4:2
#define  command_power_GND_XP42_OFF							26 //    ,  
																									 //   																									   
//Read 
#define  command_power_Stat_VoltCURR						25 //  :  ,   ,  
																									 //  
#define  command_power_StatVoltageCan2					27 //      ,  :
																									 
//+++++++++++++++++     1..25 (25)
//write 
#define  command_power25m_Chan_ON  							10 //   
#define  command_power25m_Set_curr							20 //    0..25 
#define  command_power25m_Chan_curr_out					30 //     
#define  command_power25m_XP5_1_measure					50 //c    XP5:1
//Read 
#define  command_power25m_StatusChannel					60 //  

//+++++++++++++++++    3-24 (3)
//write 
#define  command_power24V_zamer  								33 //       
#define  command_power24V_setU  								34 //    1,2 
#define  command_power24V_izmChen_ON_OFF      	35 ///   1,2 
#define  command_power24V_zamerRES							36 //      
//Read 
#define  command_power24V_readUload							37 //    ADC_U_LOAD1, ADC_U_LOAD2,
 																									 //c   
#define  command_power24V_ToMeasureAmp_E_24			38 //   +E,24
#define  command_power24V_ToMeasureAmp_18_15		39 //   +18,15
#define  command_power24V_ToMeasureAmp_12_8			41 //   +12,8
#define  command_power24V_ToMeasureAmp_5_3			42 //   +5,3.3
#define  command_power24V_readPower_regim				43 //       

//+++++++++++++++++    ()
//write 
#define  command_commmutator_Chan_ON_OFF 				20 ///    N 
#define  command_commmutator_MChannels_ON_OFF		21 /// M 
//Read 
#define  command_commmutator_Status_read				22 //   
							
//+++++++++++++++++    20..170 (170)
//write 
#define  command_power170_Chan_ON  							10 //   
#define  command_power170_Set_curr							20 //    0..25 
#define  command_power170_Chan_curr_out					30 //     
#define  command_power170_XP5_1_measure					50 //c    XP5:1
//Read 
#define  command_power170_StatusChannel					60 //  

//+++++++++++++++++//  (   )
#define  command_addrmod_RESET									40 																																							

//  

#define Channel_1							1
#define Channel_2							2
#define Channel_3							3
#define Channel_4							4

#define canal_1_Off						0b00000000
#define canal_1_On						0b00000001
#define canal_2_Off						0b00000000
#define canal_2_On						0b00000010
#define canal_1and2_Off				0b00000000
#define canal_1and2_On				0b00000011

//--------------------------------------
//      I2C:
//--------------------------------------

//     I2C( +,8   = 0)
//  ( ACK   ),   1
//    "0"
char I2CADDRWrite(unsigned char ADDRmod);
																																																			// I2C
//   ( +; 8   = 1)
//  ( ACK   ),   1
//    "0"
char I2CADDRWread(unsigned char ADDRmod);

//   
///  5 (   )  I2C    BUF_I2C_WRITE[5]
// "1",   ACK
// "0",      ACK
//unsigned char ADDRmod  -  
char WRITE_MODUL(unsigned char ADDRmod,unsigned char *pnt);	
																											//:
																											//WRITE_MODUL(SINUS_GEN,BUF_I2C_WRITE);
																											// 5    BUF_I2C_WRITE   

//   
//:    BUF_I2C_WREAD[5]   N 
// "1",   ACK
// "0",      ACK
char READ_MODUL(unsigned char ADDRmod,unsigned char KOD_KOM,unsigned char *pnt);
																											//:
																											//READ_MODUL(SINUS_GEN,20,BUF_I2C_READ)
																											//   
																																																		// I2C
//+++++++++++ :
//  ( 33)
char setAMPSINUS(unsigned int AMP); //
//  (34)
//  ( 36)
//  ( 37)
//   N ( 38)
//   N  ( 39)

//  

/*************************************************************************
**************************************************************************
***********************************************************************
**************************************************************************
*************************************************************************/

//     ADC ( - adcread_Extchan_mV)
#define ADC_1	  	3			
#define ADC_2			2
#define ADC_3			1
#define ADC_4			0
#define ADC_5			6
#define ADC_6			8
#define ADC_7			9
#define ADC_8			10
#define ADC_9			11
#define ADC_10		12
#define ADC_11		13
#define ADC_12		14
#define ADC_13		15
#define ADC_E_SW	7

//       :
//1)   ADC_1...ADC_5
#define Kadc_25V 		VDD/1024*0.1
//  ADC_6...ADC_9
#define Kadc_12V 		VDD/1024*0.2
//  ADC_E_SW
#define Kadc_E_SW 	VDD/1024*0.3773

/*/ :
EnableADC1;  						// 
DisableADC1; 						// 
EnableIntADC1;  				//.  A
DisableIntADC1;					//.  A
//*/

// A:
//  ADC    
// : Tconv=12*Tad = 1,125 Tsamp=10*Tad=10*93,75=937,5,   2.0625	
// 
// .
extern void ADCinit(void);

// ,      
extern unsigned int adcread_BUF(void); 		//  

//  ADC     AN0..AN15
extern void adcKAN(char kanADC);					//: set_adc_chan(ADC_13) -   ADC_13

//    
// ,       ,   
//char channel -  (ADC_1..ADC13,ADC_E_SW),  #define
extern unsigned int adcread_Extchan_mV(char channel); 		//  
